#!/usr/bin/env ruby

# 温度
sts = []
[15, 20, 25, 30].each {|t|
	puts '%16.4f' % t
	puts '%16.4f' % [st = (t + 46.85) * 65536 / 175.72]
	st /= 4
	st = (st + 0.5).to_i
	st *= 4
	puts '%16.4f, %16s' % [st, st.to_s(2)]
	sts << st
	puts
}
puts

def conv_t(st)
	yield st_h = st / 119						# 2^16 / 175.72 * 32 / 100
	yield st_lx = (st % 119) << 8
	yield st_l = st_lx / 952					# 119 * 2^8 / 32
	yield result = ((st_h << 5) + st_l) - 4685 - 20	# tuning
	result
end

sts.each {|st|
	puts '%16.4f' % [(st * 175.72 / 65536) - 46.85]
	conv_t(st) {|v| p v }
	puts
}
puts

st = sts.first
while(st <= sts.last)
	print '%16.4f  ' % [tt = (st * 175.72 / 65536) - 46.85]
	print '%16.4f  ' % [ct = conv_t(st) {} / 100.0]
	print '%16.4f  ' % [ct - tt]
	puts
	st += 4
end
puts

# 湿度
srhs = []
[30, 40, 50, 60].each {|rh|
	puts '%16.4f' % rh
	puts '%16.4f' % [srh = (rh + 6) * 65536 / 125.0]
	srh /= 4
	srh = (srh + 0.5).to_i
	srh *= 4
	puts '%16.4f, %16s' % [srh, srh.to_s(2)]
	srhs << srh
	puts
}
puts

def conv_rh(srh)
	yield srh_h = srh / 168						# 2^16 / 125 * 32 / 100
	yield srh_lx = (srh % 168) << 8
	yield srh_l = srh_lx / 1344					# 168 * 2^8 / 32
	yield result = ((srh_h << 5) + srh_l) - 600 + 8	# tuning
	result
end

srhs.each {|srh|
	puts '%16.4f' % [(srh * 125.0 / 65536) - 6]
	conv_rh(srh) {|v| p v }
	puts
}
puts

srh = srhs.first
while(srh <= srhs.last)
	print '%16.4f  ' % [trh = (srh * 125.0 / 65536) - 6]
	print '%16.4f  ' % [crh = conv_rh(srh) {} / 100.0]
	print '%16.4f  ' % [crh - trh]
	puts
	srh += 4
end
puts

