#ifndef _LIBI2C_H
#define _LIBI2C_H

#include <pic16f648a.h> // /usr/share/sdcc/non-free/include/pic14/pic16f648a.h, /usr/share/sdcc/include/pic14/pic16f648a.h
//#include <pic18fregs.h>	// /usr/share/sdcc/include/pic16/pic18f*.h

#define I2C_TRISCL	TRISB3
#define I2C_TRISDA	TRISB4
#define I2C_OUT		0
#define I2C_IN		1
#define I2C_SCL		RB3
#define I2C_SDA		RB4

#define I2C_EEPROM_ADR	0b1010000

#define I2C_SHT21_ADR	0b1000000
#define I2C_SHT21_T		0b0011
#define I2C_SHT21_RH	0b0101

#define I2C_LPS331AP_ADR0	0b1011100
#define I2C_LPS331AP_ADR1	0b1011101

#define I2C_LPS331AP_CTRL_REG1		0b00100000
#define I2C_LPS331AP_PRESS_OUT_XL	0b00101000
#define I2C_LPS331AP_PRESS_OUT_L	0b00101001
#define I2C_LPS331AP_PRESS_OUT_H	0b00101010
#define I2C_LPS331AP_TEMP_OUT_L		0b00101011
#define I2C_LPS331AP_TEMP_OUT_H		0b00101100

/*	16F648A	  _______
			-|2	 U	1|-	
			-|3		0|-	
			-|4	 A	7|-	
			-|5		6|-	
	GND		-|		 |-	Vcc
			-|0		7|-	
			-|1		6|-	
			-|2	 B	5|-	
	SCL		-|3_____4|-	SDA
*/

extern unsigned char i2c_adr0;		// 				<i2c_adr2>	<i2c_adr1>	<i2c_adr0>
extern unsigned char i2c_adr1;		// 256Kbits:	1010_0AAW	0aaa_aaaa	aaaa_aaaa	15bits/ 32Kbytes
extern unsigned char i2c_adr2;		//   1Mbits:	1010_AAaW	aaaa_aaaa	aaaa_aaaa	17bits/128Kbytes
extern unsigned char i2c_ctrl;
extern unsigned char i2c_data;
extern unsigned char i2c_data1;
extern unsigned char i2c_data2;

void i2c_init();
void i2c_eeprom_byte_write();
void i2c_eeprom_page_write_start();
void i2c_eeprom_page_write();
void i2c_eeprom_page_write_stop();
void i2c_eeprom_random_read();
void i2c_eeprom_cur_read();
void i2c_st7032_send();
void i2c_sht21_nohold();
void i2c_lps331ap_write();
void i2c_lps331ap_read();

#endif /* _LIBI2C_H */

